package drzewa;
import java.awt.*;

/**
 *taki przycisk z liczba reprezentujacy wierzcholek w drzewie
 *jesli bedziemy mu wywolywac co chwile metode krok(), to
 *bedzie sie plynnie przesowal do pozycji pos (ktora mozemy
 *dowolnie zmieniac w dowolnej chwili)
 *ogolnie jak mowa o pozycji to zawsze znaczy pozycja SRODKA wierzcholka
 */
public class Wierzcholek extends Button implements IKrok {
    
    int val; // wartosc w wierzcholku
    
    /**
     *to jest pozycja DOCELOWA (do ktorej dochodzimy krokami)
     *mozna ja dowolnie zmieniac i wierzcholek bedzie sie do niej przesowal
     */
    public Point pos;
    
    /**
     *zwraca aktualna pozycje wierzcholka
     */
    public Point getAktPos() {
        return new Point(getX()+getWidth()/2,getY()+getHeight()/2);
    }
    
    /**
     *przesowa wierzcholek (natychmiastowo - a nie jak pole pos
     */
    public void setAktPos(Point pos) {
        setLocation(pos.x-getWidth()/2,pos.y-getHeight()/2);
    }
    
    public Wierzcholek(int aval) { setVal(aval); pos = getAktPos(); lastpos = pos; }
    public Wierzcholek() { setVal(0); pos = getAktPos(); lastpos = pos; }
    
    /**
     *zmienia liczbe pamietana w wierzcholku
     */
    public void setVal(int aval) {
        val = aval;
        super.setLabel(new StringBuffer().append(aval).toString());
    }
    
    /**
     *zwraca liczbe pamietana w wierzcholku
     */
    public int getVal() { return val; }
    
    Point lastpos;
    public void krok() {
        Point aktpos = getAktPos();
        setAktPos(C.Krok(lastpos,aktpos,pos));
        lastpos = aktpos;
    }
}

